#include "stdafx.h"
#include "RxHelper.h"
#include <atlstr.h> //for CAtlString CA2T ..
#include <string>
#include <strsafe.h>
#include "rapidxml/rapidxml_print.hpp"
#include "conversion.h"

#include <wininet.h>
#pragma comment(lib, "Urlmon.lib")
#pragma comment(lib, "wininet.lib")

/* ******************************************************************************************************************* /
 *
 *	RxUtil 
 *
 * ********************************************************************************************************************/

#define  ELEM_DELIM _T('/')

/**
 *	@brief file  pOut ҴѴ. delete [] Ͽ Ѵ.
 */

int  RxHelper::ReadFileContent(LPCTSTR fileName, OUT char* & pOut)
{
	pOut = NULL;
	int fileSize = 0;
	FILE *fp = NULL;

	do
	{
		_tfopen_s( &fp, fileName, _T("rb") );
		if ( fp == NULL )
		{
			ATLASSERT(!"xml file notfound");
			break;
		}

		//  ũ⸦ о´.
		fseek( fp, 0l , SEEK_END );
		fileSize = ftell(fp);
		fseek( fp, 0l , SEEK_SET );

		if ( fileSize == 0 )
		{
			break;		
		}

		// 1MB  ũ ̻ݾ
		if ( fileSize >= 1024 * 1024 )
		{
			break;
		}
		// +2 NULL NULL ڸ (ڵ  )
		pOut = new char [ fileSize + 2 ];
		if ( pOut == NULL )
		{
			ATLASSERT( !"Memory allocation Failed");
			break;
		}

		size_t readCount = fread( pOut, fileSize, 1, fp );
		if ( readCount != 1 )
		{
			delete [] pOut;
			pOut = NULL;
			fileSize = 0; //return Value
			ATLASSERT( !"xml fread() error");
			break;
		}
		pOut [ fileSize ] = NULL;
		pOut [ fileSize + 1 ] = NULL;
	}
	while( FALSE );

	if ( fp )
	{
		fclose(fp);
	}

	return fileSize;
}

RxNode* RxHelper::AddChild( RxNode* p , LPCTSTR strName, LPCTSTR szValue )
{
	try 
	{
		xml_document<TCHAR> *doc = p->document();
		IfFailedReturnNull( doc );

		LPTSTR nodeName = doc->allocate_string( strName );
		RxNode* node = doc->allocate_node( node_element, strName, szValue );
		IfFailedReturnNull( node );

		p->append_node(  node );
		return node;
	}
	catch( rapidxml::parse_error& ex  )
	{		
		RxHelper::SetError(ex);
		ATLASSERT(!"AddChild Failed");
	}
	return NULL;
}

RxNode* RxHelper::NodeElement( RxNode* p, LPCTSTR szNodes, BOOL bIfEmptyCreate  )
{
	IfFailedReturnNull(p);         
	CAtlString strName;
	int pos = 0, start = 0;
	bool bExit = false;

	const CAtlString strNodes(szNodes);
	pos = strNodes.Find( ELEM_DELIM, start) ;
	do
	{            
		if ( pos > 0)
		{
			strName = strNodes.Mid(start, pos-start);
		}
		else
		{
			strName = strNodes.Mid(start);
			bExit = true;
		}

		if ( strName.IsEmpty() )
		{
			return NULL;
		}

		RxNode* p2 = p->first_node( strName );
		if ( NULL == p2 )
		{
			if ( ! bIfEmptyCreate )
			{
				return NULL;
			}
			p2 = AddChild( p, strName, NULL );
			IfFailedReturnNull( p2 );
		}
		p = p2;
		if ( bExit )
		{
			break;
		}
		start = pos + 1 ;
		pos = strNodes.Find( ELEM_DELIM, start);
	} while( TRUE );

	return p;
}

LPCTSTR RxHelper::Text( RxNode* p, LPCTSTR szDefult )
{
	// RxNode Element ƴ϶ Ÿ 쵵 ֱ  ⼭ ȮѴ
	if ( p->type() == node_data || p->type() == node_cdata)
	{
		return p->value();
	}

	RxNode *node = p->first_node();
	IfFailedReturnX(node, szDefult);

	if ( node->type() == node_data || node->type() == node_cdata)
	{
		return node->value();
	}
	return szDefult;
}

LPCTSTR RxHelper::NodeText( RxNode* p, LPCTSTR szNodes, LPCTSTR szDefault )
{
	RxNode* node = RxHelper::NodeElement( p, szNodes, FALSE );
	IfFailedReturnX(node, szDefault);
	return Text(node, szDefault);
}

LPCTSTR RxHelper::Attribute(RxNode* p, LPCTSTR szName, LPCTSTR szDefault )
{
	xml_attribute<TCHAR> *attr = p->first_attribute( szName );
	IfFailedReturnX( attr, szDefault );
	return attr->value();
}

LPCTSTR RxHelper::NodeAttribute( RxNode* p, LPCTSTR szNodes, LPCTSTR szName, LPCTSTR szDefault )
{
	RxNode* node = RxHelper::NodeElement( p, szNodes, FALSE );
	IfFailedReturnX(node, szDefault);
	return Attribute(node, szName, szDefault);
}

BOOL RxHelper::SetText(RxNode* p, LPCTSTR text)
{
	try
	{
		xml_node<TCHAR> *node = p->first_node();
		xml_document<TCHAR> *doc = p->document();
		IfFailedReturnFalse( doc );

		// ù ؽƮ 带 
		if( node == NULL )
		{
			node = doc->allocate_node( node_data );
			LPTSTR val = doc->allocate_string( text );
			node->value( val );
			p->append_node( node );
			return TRUE;
		}
		else if ( node->type() == node_data || node->type() == node_cdata )
		{
			LPTSTR val = doc->allocate_string( text );
			node->value( val );
			return TRUE;
		}
	}
	catch( rapidxml::parse_error &ex )
	{		
		RxHelper::SetError(ex);
		ATLASSERT(!"SetText Failed");
		return FALSE;
	}

	return FALSE;
}

BOOL RxHelper::SetAttribute( RxNode*p, LPCTSTR name, LPCTSTR value )
{
	try
	{
		xml_document<TCHAR> *doc = p->document();
		IfFailedReturnFalse( doc );

		xml_attribute<TCHAR> *attr = p->first_attribute( name );

		if ( attr == NULL )
		{
			LPTSTR val = doc->allocate_string( value );
			attr = doc->allocate_attribute( name, val );
			p->append_attribute( attr );
		}
		else
		{
			LPTSTR val = doc->allocate_string( value );
			attr->value( val );
		}
	}
	catch( rapidxml::parse_error &err )
	{
		RxHelper::SetError(err);
		ATLASSERT(!"SetAttribute Failed");
		return FALSE;
	}

	return TRUE;
}

BOOL RxHelper::RemoveChild( RxNode*p, RxNode* child )
{	
	try
	{
		p->remove_node( child );
		return TRUE;
	}
	catch( rapidxml::parse_error &err )
	{
		RxHelper::SetError(err);
		ATLASSERT(!"RemoveChild Failed");
	}
	return FALSE;
}

void RxHelper::SetError(rapidxml::parse_error &ex)
{
	StringCchCopy( m_szErrorMsg, kErrorMsgLength, CA2T(ex.what()) );
	StringCchCat ( m_szErrorMsg, kErrorMsgLength, LPCTSTR(ex.where<TCHAR>()) );	
}

void RxHelper::SetError(LPCTSTR szErrorMsg)
{
	StringCchCopy( m_szErrorMsg, kErrorMsgLength, szErrorMsg );
}

TCHAR RxHelper::m_szErrorMsg[ kErrorMsgLength ] = { NULL };


/* ******************************************************************************************************************* /
 *
 *	CRxDoc 
 *
 * ********************************************************************************************************************/

BOOL CRxDoc::LoadFile( LPCTSTR fileName)
{
	IfFailedReturnFalse( fileName );
	enum 
	{ 
		unknown = 0, 
		utf_8, 
		utf_16be, 
		utf_16le 
	} encoding = unknown;

	m_bOK = FALSE;

	// ڵ  Ȯ
	char* fileContent = NULL;
	int fileSize =  RxHelper::ReadFileContent( fileName, fileContent);
	if ( fileSize == 0 || fileContent == NULL )
	{		
		RxHelper::SetError(fileName);
		ATLASSERT(!"ReadFileContent Failed or Filesize is 0");
		return m_bOK;
	}

	try
	{
		if ( fileSize < 3 )
		{
			throw _T("xml fileSize less than 3");
		}

		
		char* xmlString = fileContent;
		// ڵ Ÿ ˻մϴ.
		{
			// Ʈ  ũ о´.
			BYTE BOM[3];	
			memcpy( BOM, fileContent, 3);	

			if ( BOM[0] == 0xEF && BOM[1] == 0xBB && BOM[2] == 0xBF )
			{
				encoding = utf_8;
				xmlString += 3;
			}
			else if ( BOM[0] == 0xFE && BOM[1] == 0xFF )
			{
				encoding = utf_16be;		
				xmlString += 2;
			}
			else if( BOM[0] == 0xFF && BOM[1] == 0xFE )
			{
				encoding = utf_16le;
				xmlString += 2;
			}
			else
			{
				//fileContent utf-8ڿ ȮѴ.
				//    xml  ڿ ãƺ.
				char *pos = strstr( xmlString, "?>" );
				if ( pos )
				{				
					char szLine[MAX_PATH] = { NULL };
					const int copy_size = min(MAX_PATH, int( pos- xmlString) );				
					memcpy( szLine, xmlString, copy_size );
					
					CAtlStringA strFirstLine( szLine );
					strFirstLine.MakeLower();

					// ڵ Ȯ
					if( strFirstLine.Find( "utf-8" ) > 0 || strFirstLine.Find( "utf8" ) > 0 )
					{
						encoding = utf_8;
					}
				}
			}
		}		

		LPTSTR text = NULL;
		
		if( encoding == utf_8 )
		{
			CConversion conv;
			text = m_XmlDoc.allocate_string( conv.UTF8_TO_TCHAR(xmlString) );
		}
		else if ( encoding == utf_16le )
		{
			text = m_XmlDoc.allocate_string( (LPCTSTR)xmlString );
		}
		else if ( encoding == utf_16be )
		{
			throw _T("fileEncoding utf_16be not supported!");
		}
		else
		{
			CA2T p ( xmlString );
			text = m_XmlDoc.allocate_string( p );
		}

		ATLASSERT( text != NULL );
		if ( text == NULL )
		{
			throw _T("Memory allocation error");
		}

		m_XmlDoc.parse < parse_declaration_node | parse_pi_nodes | parse_validate_closing_tags > ( text );
		m_bOK = TRUE;
	}
	catch( rapidxml::parse_error &ex )
	{
		RxHelper::SetError(ex);
		ATLASSERT(!"LoadFile Failed");
	}
	catch( const TCHAR* szErrorMsg )
	{
		RxHelper::SetError( szErrorMsg );
		ATLASSERT(!"LoadFile Failed: Unknonw Error");		
	}
	
	delete []fileContent;

	return m_bOK;
}

BOOL CRxDoc::ParseString( LPCTSTR xmlString )
{
	m_bOK = FALSE;
	try
	{
		LPTSTR text = m_XmlDoc.allocate_string( xmlString );
		m_XmlDoc.parse < parse_declaration_node | parse_pi_nodes | parse_validate_closing_tags > ( text );
		m_bOK = TRUE;
	}
	catch( rapidxml::parse_error &err )
	{
		RxHelper::SetError(err);
		ATLASSERT(!"ParseString Failed");
	}
	return m_bOK;
}

BOOL CRxDoc::LoadURL( LPCTSTR szURL)
{
	TCHAR szPath[MAX_PATH] = { NULL };
	DeleteUrlCacheEntry( szURL );
	if ( S_OK == URLDownloadToCacheFile( NULL, szURL, szPath, _countof(szPath), 0, NULL) )
	{
		return LoadFile( szPath);
	}
	ATLASSERT( !" http:// file Download Failed !");
	return FALSE;
}

BOOL CRxDoc::NewDocument( LPCTSTR startElement )
{
	m_bOK = FALSE;
	try
	{
		// , Ʈ  
		LPTSTR rootname = m_XmlDoc.allocate_string( startElement );

		RxNode* decl;
		RxNode* root;

		decl = m_XmlDoc.allocate_node( node_declaration );
		root = m_XmlDoc.allocate_node( node_element, rootname );
		IfFailedReturnFalse( root );
		IfFailedReturnFalse( decl );

		decl->append_attribute(
			m_XmlDoc.allocate_attribute( _T("version"), _T("1.0") ) );
		decl->append_attribute(
			m_XmlDoc.allocate_attribute( _T("encoding"), _T("utf-8") ) );

		m_XmlDoc.append_node(decl);
		m_XmlDoc.append_node(root);
		m_bOK = TRUE;
	}
	catch( rapidxml::parse_error &err )
	{		
		RxHelper::SetError(err);
		ATLASSERT(!"NewDocument Failed");
	}

	return m_bOK;
}


CRxEle CRxDoc::Root()
{
	RxNode* node = m_XmlDoc.first_node();
	//    ģ.
	while ( node && node->type() != node_element )
	{
		node = node->next_sibling();
	}
	return  CRxEle(node);
}


CRxEle CRxDoc::Declaration()
{
	RxNode* node = m_XmlDoc.first_node();
	//  带 Ѵ.
	if( node && node->type() == node_declaration )
	{
		return CRxEle( node );
	}
	return CRxEle(node);
}


BOOL CRxDoc::SaveFile( LPCTSTR fileName )
{
	// 
	FILE* fp = NULL;
	_tfopen_s( &fp, fileName, _T("wb"));
	if ( fp == NULL )
	{		
		RxHelper::SetError(_T("fileOpen error"));
		ATLASSERT( ! "SaveFile Failed : fileOpen error");
		return FALSE;
	}

	//ڵ utf-8 Ȯؼ ƴѰ utf-8 óѴ.
	CRxEle decl = Declaration();
	if ( decl )
	{
		CAtlString str = decl.Attribute(_T("encoding"));
		if ( str.CompareNoCase(_T("utf-8")) != 0 )
		{
			decl.SetAttribute(_T("encoding"), _T("utf-8"));
		}
	}

#ifdef _UNICODE
	std::wstring xml_as_string;
#else
	std::string xml_as_string;
#endif
	rapidxml::print(std::back_inserter( xml_as_string), m_XmlDoc );

	//  Ʈ UTF_8 ȯ
	CConversion conv;
	LPSTR str = conv.TCHAR_TO_UTF8( xml_as_string.c_str() );	
	fwrite( str, strlen(str), 1, fp);
	fclose(fp);

	return TRUE;
}
